package routes

import (
	"crowsnest/internal/data"
	"crowsnest/internal/model"
	"crowsnest/internal/viewmodel"
	"html/template"
	"net/http"
)

// sort criteria
type articleDateOrder struct {}
func (ord articleDateOrder) Weight(a *model.Article) int {
    return int(a.PublishDate.Unix())
}

// List the latest articles using the base template. 
func Index(w http.ResponseWriter, req *http.Request) {
    // retrieve from repo
    fds, err := data.NewFileDatastore("./persistence/spiegel100.json")
    if err != nil { http.Error(w, "Failed to load datastore", http.StatusInternalServerError); return; }
    repo, err := data.NewDefaultRepository[*model.Article](fds, "article")
    if err != nil { http.Error(w, "Failed to create repository", http.StatusInternalServerError); return; }
    articles, err := repo.GetByCriteria(articleDateOrder{})
    if err != nil { http.Error(w, "Failed to get articles", http.StatusInternalServerError); return; }

    // truncate
    if len(articles) > 10 {
        articles = articles[:10]
    }

    // convert to viewmodel
    articleVMs := make([]*viewmodel.ArticleViewModel, 0, len(articles))
    for _, a := range articles {
        articleVMs = append(articleVMs, viewmodel.NewArticleViewModel(a))
    }

    // render template
    t := template.Must(template.ParseFiles("templates/article.html", "templates/layout.html"))
    err = t.ExecuteTemplate(w, "base", articleVMs)
    if err != nil { http.Error(w, "Failed to render template", http.StatusInternalServerError); return; }
}
